package bytecode;

import static org.junit.Assert.*;

import java.io.File;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.URL;
import java.net.URLClassLoader;

import org.junit.BeforeClass;
import org.junit.Test;

import de.dhbwstuttgart.core.JavaTXCompiler;

public class PreIncTest {
	private static String path;
	private static File fileToTest;
	private static JavaTXCompiler compiler;
	private static ClassLoader loader;
	private static Class<?> classToTest;
	private static String pathToClassFile;
	private static Object instanceOfClass;
	
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		path = System.getProperty("user.dir")+"/src/test/resources/bytecode/javFiles/PreInc.jav";
		fileToTest = new File(path);
		compiler = new JavaTXCompiler(fileToTest);
		pathToClassFile = System.getProperty("user.dir")+"/src/test/resources/testBytecode/generatedBC/";
		compiler.generateBytecode(pathToClassFile);
		loader = new URLClassLoader(new URL[] {new URL("file://" + pathToClassFile)});
		classToTest = loader.loadClass("PreInc");
		instanceOfClass = classToTest.getDeclaredConstructor().newInstance();
	}

	@Test
	public void testM() throws NoSuchMethodException, SecurityException, IllegalAccessException, IllegalArgumentException, InvocationTargetException {
		Method m = classToTest.getDeclaredMethod("m");
		Integer res = (Integer) m.invoke(instanceOfClass);
		assertEquals(new Integer(1), res);
	}
	
	@Test
	public void testM2() throws NoSuchMethodException, SecurityException, IllegalAccessException, IllegalArgumentException, InvocationTargetException {
		Method m = classToTest.getDeclaredMethod("m2");
		Integer res = (Integer) m.invoke(instanceOfClass);
		assertEquals(new Integer(1), res);
	}
	
	@Test
	public void testD() throws NoSuchMethodException, SecurityException, IllegalAccessException, IllegalArgumentException, InvocationTargetException {
		Method m = classToTest.getDeclaredMethod("d");
		Integer res = (Integer) m.invoke(instanceOfClass);
		assertEquals(new Integer(-1), res);
	}
	
	@Test
	public void testD2() throws NoSuchMethodException, SecurityException, IllegalAccessException, IllegalArgumentException, InvocationTargetException {
		Method m = classToTest.getDeclaredMethod("d2");
		Integer res = (Integer) m.invoke(instanceOfClass);
		assertEquals(new Integer(-1), res);
	}

}
